/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright (c) 2008-2009 Hewlett-Packard, Inc. All rights reserved.
 * Use is subject to license terms.
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package com.hp.opencall.jmsc.test.mandatory.functional;


import java.util.ArrayList;
import java.util.List;

import com.hp.opencall.jmsc.test.mandatory.functional.join.InitJoinTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mediagroup.PlayerTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mediagroup.PromptAndCollectTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mediagroup.PromptAndRecordTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mediagroup.RecorderTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mediagroup.signals.DTMFBufferingTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mediagroup.signals.SignalDetectorTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mixer.MixerAdapterTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mixer.MixerJoinTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mixer.MixerMediaGroupTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mixer.MixerTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mixer.ParticipantDTMFTest;
import com.hp.opencall.jmsc.test.mandatory.functional.mixer.ParticipantJoinTest;
import com.hp.opencall.jmsc.test.mandatory.functional.networkconnection.CodecPolicyTest;
import com.hp.opencall.jmsc.test.mandatory.functional.networkconnection.NetworkConnectionTest;
import com.hp.opencall.jmsc.test.mandatory.functional.resource.ConfirmTest;
import com.hp.opencall.jmsc.test.mandatory.functional.vxml.VxmlTest;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * This Junit test suite gathers all the mandatory functional testcases.
 *
 */
public class AllTests {
	
	public static List<Class<? extends TestCase>> testClasses = new ArrayList<Class<? extends TestCase>>();
	static {
		// Basic objects features
		testClasses.add(PlayerTest.class);
		testClasses.add(RecorderTest.class);
		testClasses.add(SignalDetectorTest.class);
		testClasses.add(DTMFBufferingTest.class);
		testClasses.add(NetworkConnectionTest.class);
		testClasses.add(MediaSessionTest.class);
		testClasses.add(MixerTest.class);
		// Avanced Mixer-related features
		testClasses.add(MixerAdapterTest.class);
		testClasses.add(MixerJoinTest.class);
		testClasses.add(MixerMediaGroupTest.class);
		testClasses.add(ParticipantJoinTest.class);
		testClasses.add(ParticipantDTMFTest.class);
		// Advanced mixed testcases
		testClasses.add(MediaObjectIdTest.class);
		testClasses.add(CodecPolicyTest.class);
		// Composite features
		testClasses.add(PromptAndCollectTest.class);
		testClasses.add(PromptAndRecordTest.class);
		// static testcase (does not require a media server)
		testClasses.add(SupportedFeaturesTest.class);
		testClasses.add(MediaConfigTest.class);
		// Async methods
		testClasses.add(InitJoinTest.class);
		testClasses.add(ConfirmTest.class);
		// Vxml basic test (failure allowed)
		testClasses.add(VxmlTest.class);
	}
	
	public static Test suite() {
		TestSuite suite = new TestSuite("All mandatory functional testcases of the JSR 309 TCK");

		for (Class<? extends TestCase> c : AllTests.testClasses) {
            suite.addTestSuite(c);
        }		
		return suite;
	}

}
