/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright (c) 2009 Hewlett-Packard, Inc. All rights reserved.
 * Use is subject to license terms.
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package com.hp.opencall.jmsc.test.mandatory.functional.resource;

import javax.media.mscontrol.mixer.MediaMixer;
import javax.media.mscontrol.resource.AllocationEvent;
import javax.media.mscontrol.resource.AllocationEventListener;

import org.apache.log4j.Logger;

import com.hp.opencall.jmsc.test.MediaSessionBase;

public class ConfirmTest extends MediaSessionBase {
	static Logger log = Logger.getLogger(ConfirmTest.class);

	public ConfirmTest() {
		super();
	}
	public ConfirmTest(String method) {
		super(method);
	}
	/**
	 * Call {@link javax.media.mscontrol.resource.ResourceContainer#confirm()} on a {@link MediaMixer}.
	 * <br>Verify that the listener is called, with proper values.
	 */
	public void test_2_1_17_1_ConfirmMixer() throws Exception {
		MediaMixer myMixer = myMediaSession.createMediaMixer(MediaMixer.AUDIO);
		final Integer[] state = { 0 };
		myMixer.addListener(new AllocationEventListener() {
			/* (non-Javadoc)
			 * @see javax.media.mscontrol.StatusEventListener#onEvent(javax.media.mscontrol.StatusEvent)
			 */
			@Override
			public void onEvent(AllocationEvent anEvent) {
				log.debug("Received: "+anEvent);
				assertEquals("Bad event type", AllocationEvent.ALLOCATION_CONFIRMED, anEvent.getEventType());
				state[0] = 1;
			}			
		});
		synchronized(myMixer) {
			myMixer.confirm();
			if (state[0] != 1)
				myMixer.wait(5000);
		}
		assertEquals("Bad state", new Integer(1), state[0]);
	}
}
