/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright (c) 2008-2009 Hewlett-Packard, Inc. All rights reserved.
 * Use is subject to license terms.
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package com.hp.opencall.jmsc.test.mandatory.robustness;

import java.util.ArrayList;
import java.util.List;

import com.hp.opencall.jmsc.test.mandatory.robustness.mediagroup.MediaGroupUnjoinTest;
import com.hp.opencall.jmsc.test.mandatory.robustness.mediagroup.PlayerRobustnessTest;
import com.hp.opencall.jmsc.test.mandatory.robustness.networkconnection.CodecPolicyTest;
import com.hp.opencall.jmsc.test.mandatory.robustness.resource.RTCTest;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * This Junit test suite gathers all the mandatory robustness testcases.
 *
 */
public class AllTests {
	
	public static List<Class<? extends TestCase>> testClasses = new ArrayList<Class<? extends TestCase>>();
	static {
		testClasses.add(ListenerTest.class);
		testClasses.add(MediaObjectIdTest.class);
		testClasses.add(MediaGroupUnjoinTest.class);
		testClasses.add(NullReferenceTest.class);
		testClasses.add(PlayerRobustnessTest.class);
		testClasses.add(RTCTest.class);
		testClasses.add(CodecPolicyTest.class);
		testClasses.add(UnchangedArgsTest.class);
	}
	
	public static Test suite() {
		TestSuite suite = new TestSuite("All mandatory robustness testcases of the JSR 309 TCK");

		for (Class<? extends TestCase> c : AllTests.testClasses) {
            suite.addTestSuite(c);
        }		
		return suite;
	}

}
