/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright (c) 2008-2009 Hewlett-Packard, Inc. All rights reserved.
 * Use is subject to license terms.
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package com.hp.opencall.jmsc.test.mandatory.robustness.MSFaultTestServer;

import java.util.Timer;
import java.util.TimerTask;

import javax.sip.ClientTransaction;
import javax.sip.RequestEvent;
import javax.sip.ResponseEvent;
import javax.sip.ServerTransaction;
import javax.sip.SipException;
import javax.sip.SipProvider;
import javax.sip.TransactionDoesNotExistException;
import javax.sip.TransactionUnavailableException;
import javax.sip.message.Request;



public class Test_2_2_5_1_MediaServerSendsBye extends SIPServer_Base {

	
	public static void main(String args[]) {
		new Test_2_2_5_1_MediaServerSendsBye().init();
	}
	

	class SendByeTimerTask extends TimerTask {
		Test_2_2_5_1_MediaServerSendsBye base;
		SipProvider provider;
	
		public SendByeTimerTask(Test_2_2_5_1_MediaServerSendsBye base, SipProvider provider) {
			this.base = base;
			this.provider = provider;
		}

		public void run() {
			sendBye(provider);
		}

	}
	
	public void sendBye(SipProvider  provider) {
		System.out.println("Sending Bye");
		try {
			Request byeRequest = dialog.createRequest(Request.BYE);
			ClientTransaction ct = provider
					.getNewClientTransaction(byeRequest);
			dialog.sendRequest(ct);
		} catch (TransactionUnavailableException e) {
			e.printStackTrace();
		} catch (TransactionDoesNotExistException e) {
			e.printStackTrace();
		} catch (SipException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Process the ACK request. Send the bye and complete the call flow.
	 */
	public void processAck(RequestEvent requestEvent,
			ServerTransaction serverTransaction) {
		super.processAck(requestEvent, serverTransaction);
		System.out.println("Wait for 5 seconds");
		new Timer().schedule(new SendByeTimerTask(this, (SipProvider) requestEvent.getSource()), 5000);
	}
	
	@Override
	public void processResponse(ResponseEvent responseEvent) {
		// 200 for BYE, do nothing
	}
	
}
