/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright (c) 2008-2009 Hewlett-Packard, Inc. All rights reserved.
 * Use is subject to license terms.
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package com.hp.opencall.jmsc.test.mandatory.robustness.MSFaultTestServer;

import java.text.ParseException;
import java.util.Timer;
import java.util.TimerTask;

import javax.sip.ClientTransaction;
import javax.sip.InvalidArgumentException;
import javax.sip.RequestEvent;
import javax.sip.ResponseEvent;
import javax.sip.ServerTransaction;
import javax.sip.SipException;
import javax.sip.SipProvider;
import javax.sip.TransactionDoesNotExistException;
import javax.sip.TransactionUnavailableException;
import javax.sip.header.CSeqHeader;
import javax.sip.header.ContentTypeHeader;
import javax.sip.header.MaxForwardsHeader;
import javax.sip.message.Request;
import javax.sip.message.Response;


public class Test_2_2_5_3_MediaServerSendsReInvite extends SIPServer_Base {
	
	public static void main(String args[]) {
		new Test_2_2_5_3_MediaServerSendsReInvite().init();
	}
	
	
	class SendReinviteTimerTask extends TimerTask {
		Test_2_2_5_3_MediaServerSendsReInvite base;
		SipProvider provider;
	
		public SendReinviteTimerTask(Test_2_2_5_3_MediaServerSendsReInvite base, SipProvider provider) {
			this.base = base;
			this.provider = provider;
		}

		public void run() {
			sendReInvite(provider);
		}
	}
	
	public void sendReInvite(SipProvider provider) {

			try {
				Request inviteRequest = dialog.createRequest(Request.INVITE);
				MaxForwardsHeader mf = headerFactory.createMaxForwardsHeader(35);
				inviteRequest.setHeader(mf);
				ClientTransaction ct = provider.getNewClientTransaction(inviteRequest);
				
				ContentTypeHeader cth = headerFactory.createContentTypeHeader("application", "sdp");
				inviteRequest.setContent(mssdp.getBytes(),cth );
				dialog.sendRequest(ct);
				System.out.println("Sent reInvite");
			} catch (TransactionUnavailableException e) {
				e.printStackTrace();
			} catch (TransactionDoesNotExistException e) {
				e.printStackTrace();
			} catch (SipException e) {
				e.printStackTrace();
			} catch (InvalidArgumentException e) {
				e.printStackTrace();
			} catch (ParseException e) {
				e.printStackTrace();
			}

	}
	
	/**
	 * Process the ACK request. Send the bye and complete the call flow.
	 */
	public void processAck(RequestEvent requestEvent,
			ServerTransaction serverTransaction) {
		super.processAck(requestEvent, serverTransaction);
		System.out.println("Wait for 6 seconds");
		new Timer().schedule(new SendReinviteTimerTask(this, (SipProvider) requestEvent.getSource()), 6000);
	}
	
	@Override
	public void processResponse(ResponseEvent responseEvent) {
		Response response = (Response) responseEvent.getResponse();
		if (response.getStatusCode() == Response.OK) {
			try {
				Request ackRequest = dialog.createAck( ((CSeqHeader) response.getHeader(CSeqHeader.NAME)).getSeqNumber());
				dialog.sendAck(ackRequest);
				System.out.println("Sent ACK for reInvite");
			} catch (InvalidArgumentException e) {
				e.printStackTrace();
			} catch (SipException e) {
				e.printStackTrace();
			}
		}
	}
}
