/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright (c) 2008-2009 Hewlett-Packard, Inc. All rights reserved.
 * Use is subject to license terms.
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package com.hp.opencall.jmsc.test.mandatory.robustness.MSFaultTestServer;

import java.text.ParseException;

import javax.sip.InvalidArgumentException;
import javax.sip.RequestEvent;
import javax.sip.ServerTransaction;
import javax.sip.SipException;
import javax.sip.address.Address;
import javax.sip.header.ContactHeader;
import javax.sip.header.ContentTypeHeader;
import javax.sip.header.ToHeader;
import javax.sip.message.Request;
import javax.sip.message.Response;



public class Test_2_2_5_4_MediaServerRejectReinvite extends SIPServer_Base {

	private boolean confCreated=false;
	
	public static void main(String args[]) {
		new Test_2_2_5_4_MediaServerRejectReinvite().init();
	}
	
	@Override
	public void processInvite(RequestEvent requestEvent,
			ServerTransaction serverTransaction) {
		Request request = requestEvent.getRequest();
		ServerTransaction st = requestEvent.getServerTransaction();
		
		try {
			if(request.getRequestURI().toString().contains("conf=")) {
				if (st == null) {
					st = sipProvider.getNewServerTransaction(request);
				}
				if(!confCreated) {
					// Create the Conf
					Response resp = messageFactory.createResponse(Response.OK,
							request);
					Address address = addressFactory.createAddress("MS <sip:"
							+ fromIp + ":" + fromPort + ">");
					ContactHeader contactHeader = headerFactory
							.createContactHeader(address);
					resp.addHeader(contactHeader);
					ToHeader toHeader = (ToHeader) resp.getHeader(ToHeader.NAME);
					toHeader.setTag("4321"); // Application is supposed to set.
					resp.addHeader(contactHeader);
					String content = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><MediaServerControl version=\"1.0\"><response request=\"configure_conference\" code=\"200\" text=\"OK\"/></MediaServerControl>";
					ContentTypeHeader cth = headerFactory.createContentTypeHeader("application", "mediaservercontrol+xml");
					resp.setContent(content.getBytes(),cth );
					st.sendResponse(resp);
					confCreated=true;
				} else {
					// Reject the re-invite configure the conf 
					Response resp = messageFactory.createResponse(Response.REQUEST_PENDING,
							request);
					Address address = addressFactory.createAddress("MS <sip:"
							+ fromIp + ":" + fromPort + ">");
					ContactHeader contactHeader = headerFactory
							.createContactHeader(address);
					resp.addHeader(contactHeader);				
					st.sendResponse(resp);
				}
			} else {
				// SDP
				super.processInvite(requestEvent, serverTransaction);
			}
		} catch (ParseException e) {
			e.printStackTrace();
		} catch (SipException e) {
			e.printStackTrace();
		} catch (InvalidArgumentException e) {
			e.printStackTrace();
		}
	}
}
